# Reporting FAQ

The new Search Ads 360 Reporting API is now available. The new API provides enhanced flexibility to build custom reports and integrate the data into your reporting applications and processes. Learn more about migrating to and using the [new Search Ads 360 Reporting
API](https://developers.google.com/search-ads/reporting/overview).

### What should my report scope be?


For most reports, we recommend that you set
[`Reports.reportScope`](https://developers.google.com/search-ads/v2/reference/reports#request.reportScope)
to a specific engine account or advertiser. For very large
reports---such as keyword reports, conversion reports, or
finely-segmented reports---we recommend limiting the scope to a
specific engine account. The API may return errors for reports larger than
10 million rows.

### Why am I receiving a Forbidden (403) error?


Most likely, you need to
[obtain a refresh OAuth token](https://developers.google.com/identity/protocols/oauth2#5.-refresh-the-access-token,-if-necessary).

### How do I find IDs for agencies and advertisers?


If you don't already have the IDs for the agencies and advertisers you have
permission to view, request an
[`advertiser`](https://developers.google.com/search-ads/v2/report-types/advertiser)
report with the `agencyId` and `advertiserId` columns,
but don't specify the [`reportScope`](https://developers.google.com/search-ads/v2/reference/reports#request.reportScope).
Search Ads 360 will return a list of all agency and advertiser IDs that your
Google Account has permission to view.

Here's an example request:

```
POST  https://www.googleapis.com/doubleclicksearch/v2/reports/generate
Authorization: Bearer your OAuth 2.0 access token
Content-type: application/json
{
  "reportType": "advertiser",
  "columns": [
    { "columnName": "agency" },
    { "columnName": "agencyId" },
    { "columnName": "advertiser" },
    { "columnName": "advertiserId" }
  ],
  "statisticsCurrency": "usd"
}
        
```

#### Use the Search Ads 360 utility script to send this request


To send a raw JSON POST request, you can use the [sa360Api.py
script](https://developers.google.com/search-ads/v2/prereqs#ds3py) as follows:

1. Copy the example JSON object (everything between and including the two curly brackets) into a new text file named `request.txt`.
2. Change the agency ID that's in the JSON code to your own agency ID.
3. Remove any comments, such as `// The date column segments the report by individual days.`
4. Assemble your OAuth 2.0 credentials into a single, comma-delimited string as follows:  
   `client-ID,client-secret,refresh-token`   
   (This is the same string that `sa360Api.py` outputs when you run `sa360Api.py
   --login` as described in [Set Up
   Authorization](https://developers.google.com/search-ads/v2/authorizing).)
5. Invoke `sa360Api.py` as follows:  
   `sa360Api.py --cred
   CREDENTIALS --server API-method --post < request.txt
   `  
   In the command above, substitute the string you assembled in the previous step for `CREDENTIALS`.   
   Substitute the name of the POST method in the box below for `API-method`.


   For example:  
   `sa360Api.py --cred
   123456789123.apps.googleusercontent.com,ABCDEFGHIJKLMNOPQR_abcdef,1/HIJklM01OPQR23NOP456rst890uvw
   --server https://www.googleapis.com/doubleclicksearch/v2/reports/generate --post < request.txt`

> [!NOTE]
> **Note:**
>
> Because `statisticsCurrency` is a required field, specify
> `usd` in this request. In other reports that are scoped to an
> advertiser or lower, you can [request
> the report to be returned in another currency](https://developers.google.com/search-ads/v2/how-tos/reporting#currency).

### How fresh is the reporting data?


Some metrics are fresher than others. For details, see [how fresh is the reporting data
in Search Ads 360?](https://support.google.com/searchads/answer/1185359)


To make sure your reports contain all available metrics, we recommend waiting about 4
hours after midnight (engine account time zone) before requesting reports of yesterday's
metrics; for the `conversion` report, we recommend waiting for
12 hours after midnight (Campaign Manager advertiser time zone). If you use the API to upload conversion data, see
[insert.operation](https://support.google.com/searchads/answer/2604604#insert-operation)
for details about the availability of uploaded data.


Even after several days, a metric can still change due to engine spam filters or offline
conversions being uploaded via the API. To incrementally download these
changes, request [reports
on the data that has changed](https://developers.google.com/search-ads/v2/how-tos/reporting/incremental-reports) since your last download. If you download incremental
changes, we recommend that you request a full report every once in awhile. For example,
you might download incremental changes every few days and then request a full report once
a month.

### When will attribute changes appear in reports?


It takes about a minute for attribute changes that someone makes in Search Ads 360 to appear in
reports that you download via the API. Changes made directly on the external engine (not
through Search Ads 360) will need to be imported into Search Ads 360 first using [inbound sync](https://support.google.com/searchads/answer/1184686).


We recommend [returning
only the data that has changed](https://developers.google.com/search-ads/v2/how-tos/reporting/incremental-reports) to determine which entities have attribute changes.

### What are unattributed ads and keywords?


Sometimes Search Ads 360 cannot attribute metrics to a specific ad. For example, an ad with an
unsupported format or a clickserver URL with an error can prevent Search Ads 360 from attributing
metrics to an ad. For each ad group, Search Ads 360 reports any unattributed metrics as belonging to
an "unattributed ad." To request these metrics in a report, set
[`includeRemovedEntities`](https://developers.google.com/search-ads/v2/reference/reports#request.includeRemovedEntities)
to `true`. To make it easy to see which ads are unattributed, include the
`isUnattributedAd` column in the request.


Similarly, at times Search Ads 360 cannot attribute metrics to a specific keyword.
This happens when discrepancies in reporting arise. In such cases, the
`keywordId` column for unattributed keywords is set to 0.

### Do reports include scaled conversions?


In some cases, conversions are hard to measure, such as when the website cookies that store
information about your ad clicks aren't available due to factors including browser settings.
In these cases, Floodlight uses scaling to account for the conversion data that can't be
directly measured. That is, Floodlight applies machine learning to historical data to model the
number of conversions and amount of conversion revenue that cannot be measured. Floodlight can
then add the resulting estimate to its conversion metrics to provide a more complete picture of
how your advertising drives conversions.

Floodlight always applies scaling to the following reporting columns:

- dfaActions
- dfaRevenue
- dfaTransactions
- dfaWeightedActions
- [Saved columns](https://developers.google.com/search-ads/v2/how-tos/reporting/saved-columns) that report on Floodlight activities


The [`conversion`](https://developers.google.com/search-ads/v2/report-types/conversion)
report does not include scaled conversions. It only shows conversions that were measured
directly. The number of conversions and amount of revenue in a `conversion` report
are not expected to match the conversions and revenue reported in the columns listed above.

### Why do raw conversions not sum up to aggregated metric *X*?

In the rare event that aggregated metrics disagree with raw events in Search Ads 360, trust the
aggregated metric. When computing metric aggregates, Search Ads 360 attempts to sanitize data
sources by removing conversions that it suspects are duplicates.

### What if my question isn't answered here?

If there's a problem that you can't solve after reading the resources on this site,
[contact support](https://support.google.com/searchads/answer/9026876) and have the
following information ready:

- Search Ads 360 Agency ID and Advertiser ID you are trying to access

- Project Number from [Google API Console](https://console.cloud.google.com/)

- The username of the Google Account that you're using to access the API.  

  This is the account that has been [given
  permission to access Search Ads 360](https://developers.google.com/search-ads/v2/prereqs#permissions), which is the same account you use to
  [set up authorization](https://developers.google.com/search-ads/v2/authorizing).

- Code snippet of your request

- JSON response  

  If the response is an error, be sure to include the error message, not just the
  numeric error code.